<?php
class UniSenderPrototype extends Module {

	var $main_title;
	var $table_prefix;
	var $addition_to_path;
	var $module_name				= 'unisender';
	var $default_action				= 'show';
	var $tpl_path					= 'mod/unisender/tpl/';
	var $file_path					= 'files/unisender/';
	var $_msg						= array();

	function UniSenderPrototype($action = '', $transurl = '', $properties = array(), $prefix = NULL, $rewrite_mod_params = NULL, $adminurl = NULL, $noadmin = false) {
		global $main, $tpl, $tpl_path, $baseurl, $cache, $lc, $CONFIG, $PAGE, $server, $lang, $permissions, $request_type, $_RESULT;
		$this->table_prefix = ($prefix) ? $prefix : $server.$lang;
		$is_admin = Module::is_admin();
		
		//     ,  $permissions        $name
        $permissions['r'] = $_SESSION['permissions'][$this->table_prefix][$this->module_name]['r'];		// 
        $permissions['e'] = $_SESSION['permissions'][$this->table_prefix][$this->module_name]['e'];		// 
        $permissions['p'] = $_SESSION['permissions'][$this->table_prefix][$this->module_name]['p'];		// 
        $permissions['d'] = $_SESSION['permissions'][$this->table_prefix][$this->module_name]['d'];		// 

		if ('none' == $action || 'only_create_object' == $action) {
            return;
        }

		if (empty($is_admin))
		{
			$tpl_name = $this->is_valid_tpl($properties['tpl'], $action) ? $properties['tpl'] : '';
			require(RP.'mod/'.$this->module_name.'/lang/'.$this->module_name.'_'.$lang.'.php');
		  	$this->_msg = $_MSG;
			if (empty($action)) {
			}
			switch ($action) {
			default:
				if (is_object($tpl)) $tpl->prepare();
				return;
			}
		} else {
			require_once(RP.'mod/'.$this->module_name.'/lang/'.$this->module_name.'_'.$CONFIG["admin_lang"].'.php');
				$this->_msg = $_MSG;
				if (!isset($tpl)) $main->message_die(iconv("WINDOWS-1251", "UTF-8", '      '));
				if (empty($action)) $action = $this->default_action;
				switch ($action) {			
					case "show":
						$main->include_main_blocks_2($this->module_name."_export.html", $this->tpl_path);
						$tpl->prepare();
						$apikey = $this->loadKey();
						if ($apikey != NULL) {
							$tpl->assign(array(load_key => $apikey,));
						}
						$tpl->assign(array(
							"MSG_Error_no_mail_or_no_phone"		=>	$this->_msg["Error_no_mail_or_no_phone"],
							"MSG_UniSender_desc"				=>	$this->_msg["UniSender_desc"],
							"MSG_unisender"						=>	$this->_msg["unisender"],
							"MSG_Info" 							=>  $this->_msg["Info"],
							"MSG_VL" 							=>  $this->_msg["VL"],
							"MSG_Transfer"						=>	$this->_msg["Transfer"],
							"MSG_Email"							=>	$this->_msg["Email"],
							"MSG_Fname"							=>	$this->_msg["Fname"],
							"MSG_Surname"						=>	$this->_msg["Surname"],
							"MSG_Sname"							=>	$this->_msg["Sname"],
							"MSG_4number"						=>	$this->_msg["4number"],
							"MSG_SData"							=>	$this->_msg["SData"],
							"MSG_USaccount"						=>	$this->_msg["USaccount"],
							"MSG_APIkey"						=>	$this->_msg["APIkey"],
							"MSG_List"							=>	$this->_msg["List"],
							"MSG_OpenUS"						=>	$this->_msg["OpenUS"],
							"MSG_Empty_field"					=>	$this->_msg["Empty_field"],
							"MSG_Please_Select"					=>	$this->_msg["Please_Select"],
							"MSG_GetList"						=>	$this->_msg["GetList"],
							"MSG_GetFields"						=>	$this->_msg["GetFields"],
							"MSG_SaveKey"						=>	$this->_msg["SaveKey"],
							"MSG_SavePrp"						=>	$this->_msg["SavePrp"],
							"MSG_Info_for_send"					=>	$this->_msg["Info_for_send"],
							"MSG_Uname" 						=> $this->_msg["Uname"],
							"MSG_USname" 						=> $this->_msg["USname"],
							"MSG_Title" 						=> $this->_msg["Title"],
							"MSG_Save"							=> $this->_msg["Save"],
							"MSG_Cancel"						=> $this->_msg["Cancel"],
							"MSG_All_Marks"						=> $this->_msg["All_Marks"],
							"MSG_Get_Marks"						=> $this->_msg["Get_Marks"],
							"_ROOT.lang"						=>	$lang,
							"_ROOT.name"						=>	$this->module_name,
							"_ROOT.form_action"					=>	"$baseurl&action=export",
							"_ROOT.formL_action"				=>	"$baseurl&action=getList",
							"_ROOT.form_getFields_action"		=>	"$baseurl&action=getFields",
							"_ROOT.email"						=>	$CONFIG["unisender_checks_value_email"],
							"_ROOT.phone"						=>	$CONFIG["unisender_checks_value_phone"],
							"_ROOT.Sname"						=>	$CONFIG["unisender_checks_value_sname"],
							"_ROOT.Name"						=>	$CONFIG["unisender_checks_value_name"],
							"_ROOT.Surname"						=>	$CONFIG["unisender_checks_value_surname"],
						));	
							$assign = array(
							"baseurl" 			=> $baseurl,
							"action" 			=> $action,
							"MSG_Uname" 		=> $this->_msg["Uname"],
							"MSG_USname" 		=> $this->_msg["USname"],
							"MSG_Title" 		=> $this->_msg["Title"],
							"MSG_Save"			=> $this->_msg["Save"],
							"MSG_Cancel"		=> $this->_msg["Cancel"],
							"MSG_All_Marks"		=> $this->_msg["All_Marks"],
							"MSG_Get_Marks"		=> $this->_msg["Get_Marks"],
						);
						$this->showPropList($this->getPropList(), $assign);				
						break;
					case "getList":		
						$POST = array ( 'api_key' => $_POST['apikey']);
						$result = $this->CURL($_POST['apikey'],'http://api.unisender.com/ru/api/getLists?format=json', $POST);
						if ($result) {
						  $jsonObj = json_decode($result);
						  if(null===$jsonObj) {
							echo $this->_msg["Invalid"]."JSON";
						  }
						  elseif(!empty($jsonObj->error)) {
							echo $this->_msg["Error"].": ". $jsonObj->error . " (".$this->_msg["Code"].": ". $jsonObj->code .")";
						  } else {
						    echo $result;
						  }
						} else {
						  echo $this->_msg["API_access_error"];
						}
						break;
					case "getFields":
						$POST = array ( 'api_key' => $_POST['apikey']);
						$result = $this->CURL($_POST['apikey'],'http://api.unisender.com/ru/api/getFields?format=json', $POST);
						if ($result) {
						  $jsonObj = json_decode($result);
						  if(null===$jsonObj) {
							echo $this->_msg["Invalid"]."JSON";
						  }
						  elseif(!empty($jsonObj->error)) {
							echo $this->_msg["Error"].": ". $jsonObj->error . " (".$this->_msg["Code"].": ". $jsonObj->code .")";
						  } else {
							echo $result;
						  }
						} else {
						  echo $this->_msg["API_access_error"];
						}
						break;
					case "export":
						# if [1]
						if (!empty($_POST)) {
							global $i;
							$main->include_main_blocks_2($this->module_name."_export_report.html", $this->tpl_path);
							$tpl->prepare();
							$report = "";
							$tpl->assign(Array(
								"MSG_" 		=> $this->_msg["OK"],
							));
							$tpl->assign(
								array(
									"_ROOT.form_action"	=>	"$baseurl&action=show",
								)
							);
							# if [2]
							//      
							if ($_REQUEST["sList"]) {
								//      email  phone
								// USname ->    UniSender
								// check -> id ,  [id] -> []
								// [0] -> email
								# if [3]
								if (in_array("email", $_POST['check']) || in_array(array_search("phone", $_POST['USname']),$_POST['check'])) {
									global $db;
									$id 		= $this-> getUserId();
									$api_key	= $_POST['key'];
									$list		= $_POST["sList"];
									$POST		= array ('api_key' => $api_key);
									$i 			= 0;
									if (in_array("email", $_POST['check'])) {
										$POST['field_names[0]'] = 'email';
										$i++;
										//      UniSender  phone   
										if (in_array(array_search("phone", $_POST['USname']),$_POST['check'])) {
											$POST['field_names[1]'] = 'phone';
											$i++;
										}
									} else {
										$POST['field_names[0]'] = 'phone';
										$i++;
									}
									//    url
									foreach ($_POST['USname'] as $field) {
										if (in_array(array_search($field, $_POST['USname']), $_POST['check'])){
											if ( ($field != "phone") && ($field != "email") ){
												$POST['field_names['.$i.']']= $field;
												$i++;
											}
										}
									}
									$POST['field_names['.$i.']']= 'email_list_ids';
									$list_id = $i;
									$data = $this->getDataArr("");
									$uname = $this->getUname("getMarks");
									$i = 0;
									foreach ($data as $udata) {
										$j = 0;
										$all = true;
										if (in_array("email", $_POST['check'])) {
											$POST['data[' . $i .'][0]'] = $udata['email'];
											$j++;
										} else {
											if( !array_key_exists($uname[array_search("phone", $_POST['USname'])],$udata)) {
												$all = false;
											}
										}
										if ($all) {
											foreach ($udata as $field => $values) {
												if ($field!="email") {
													if ($uname[array_search ($POST['field_names['.$j.']'], $_POST['USname'])] == $field){
														$POST['data[' . $i .']['.$j.']'] = $values;
														$j++;
													}
												}
											}
											$POST['data[' . $i .']['.$list_id.']'] = $list;
											$i++;
										}
									}
									$result = $this->CURL($api_key, 'http://api.unisender.com/ru/api/importContacts?format=json', $POST);
									if ($result) {
									  $jsonObj = json_decode($result);
									  if(null===$jsonObj) {
										$report .=  $this->_msg["Invalid"]."JSON.<br/>";
									  }
									  elseif(!empty($jsonObj->error)) {
										$report .=  $this->_msg["Error"].": ". $jsonObj->error . " (".$this->_msg["Code"].": ". $jsonObj->code .").<br/>";
									  } else {
										$report .= $this->_msg["Success"]."! ".$this->_msg["Added"].": ". $jsonObj->result->new_emails.".<br/>";							
									  }
									} else {
									  $report .= $this->_msg["API_access_error"].".<br/>";
									}
												
								} else { 
									if (in_array("email", $_POST['check'])) {	
									} else {
										if (!in_array(array_search("phone", $_POST['USname']),$_POST['check'])) {
											$report .= $this->_msg["Error_no_mail_or_no_phone"].".<br/>";
										}
									}
								} # endif [3]
							} else {
								$report .= " ".$this->_msg["Please_Select"].".<br/>";
							} # endif [2]
						} else {
							$report .= " ".$this->_msg["Error_send"].".<br/>";
						} # endif [1]
						if ($_POST['savePrp']) {
							$this->saveUserPrp();
						}
						phpinfo(32);
						$tpl->assign(array(report_msg => $report,));
						$this->main_title = $this->_msg["Report"];
						break;
					default:
                    	$main->include_main_blocks();
                    	$tpl->prepare();
				}
		}
	}
	
	function saveUserPrp()
	{
		global $db;
		$id = $this-> getUserId();
		$key = $this-> loadKey();
		$this->delUserPrp();
		foreach ($_POST['check'] as $check) {
			if($_POST['USname'][$check]){
				$db->set(''.$this->table_prefix.'_unisender_prop',
					array('usname' => $_POST['USname'][$check],
					'prop_id' => intval($check),
					'apikey'  => ''.$key.'',
					'user_id' => intval($id)));
			}
		}
		if ($_POST['saveKey']) {
			$this->saveKey($_POST['key']);
		}
		if(in_array("email", $_POST['check'])){
			$db->set(''.$this->table_prefix.'_unisender_prop',
					array('usname' => "email",
					'prop_id' => intval($check),
					'apikey'  => ''.$key.'',
					'user_id' => intval($id)));
		}
	}
	function delUserPrp()
	{
		global $db;
		$id = $this-> getUserId();
		$key = $this-> loadKey();
		$db->query('DELETE FROM '.$this->table_prefix.'_unisender_prop WHERE user_id='.$id.' AND apikey=\''.$key.'\'');
	}
	/*    $url   */
	function CURL($api_key, $url, $POST)
	{
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $POST);
		curl_setopt($ch, CURLOPT_TIMEOUT, 10);
		curl_setopt($ch, CURLOPT_URL, $url);
		$result = curl_exec($ch);
		return $result;
	}
	/*       */
	function getDataArr($rows = "")
	{
		global $db;
		//         ,  
		//   ? AND email != \''.$_SESSION['session_login'].'\'
		$db->query('SELECT * FROM  core_users_prop_val AS val,  core_users AS users,  
				core_users_prop AS prop WHERE val.user_id = users.id 
				AND prop.id = val.prop_id AND email != \''.$_SESSION['session_login'].'\' ORDER BY val.user_id ASC');
		if ($db->nf() > 0) {
			while($db->next_record()) {
				$id = $db->f('user_id');
				$field = $db->f('uname');
				$data[''.$id.'']['email'] = $db->f('email');
				$data[''.$id.''][$field] = $db->f('value');
			}
			return $data;
		}
	}
	function saveKey($key)
	{
		global $db;
		$id = $this->getUserId();
		if(isset($id)) {
			$db->query('SELECT * FROM  '.$this->table_prefix.'_unisender WHERE user_id = '.$id);
			if ($db->nf() > 0) {
				$query = "UPDATE ".$this->table_prefix."_unisender SET apikey = '$key' WHERE  user_id = $id";
			} else {
				$query = "INSERT INTO ".$this->table_prefix."_unisender (user_id,apikey) 
						VALUES ($id,'$key')";
			}
			$db->query($query);
		}
	}
	
	function getUserId() 
	{
		global $db;
		$db->query('SELECT * FROM  core_users WHERE email = \''.$_SESSION['session_login'].'\'');
		if ($db->nf() > 0) {
			while($db->next_record()) {
				$id = $db->f('id');
			}
			return $id;
		} else {
			return NULL;
		}
	}
	
	function loadKey() 
	{
		global $db;
		$id = $this->getUserId();
		if(isset($id)) {
			$db->query('SELECT * FROM  '.$this->table_prefix.'_unisender WHERE user_id = '.$id);
			if ($db->nf() > 0) {
				while($db->next_record()){
					$apikey = $db->f('apikey');
				}
				return $apikey;
			} else {
				return NULL;
			}
		}
	}
	
	function getPropList($filter = false)
    {   global $db, $CONFIG;
        static $_prop_list = array();
    
        if (empty($_prop_list)) {
            $db->query("SELECT * FROM core_users_prop ORDER BY rank");
        	while ($db->next()) {
        		$_prop_list[$db->Record['id']] = $db->Record;
        		if (5 == $db->Record['type'] || 6 == $db->Record['type']) {
            	    $_prop_list[$db->Record['id']]['list_val'] = unserialize($db->Record['meta']);
            	}
        	} 
        }
    	return $_prop_list;
    }
	
	function showPropList($list, $param = array())
	{   global $tpl;
		if (empty($list)) {
		    $tpl->assign($param);
		} else {
		    $tpl->newBlock('prop_list');
			$usname_list = $this->getUname("getPrp");
		    $tpl->assign($param);
		    $i = 0; $c = count($list);
		    foreach ($list as $val) {
		        $i++;
		    	$tpl->newBlock('prop_list_item');		    			    
		    	$tpl->assign(array_merge($val, $param));
				Module::show_select('usname_list', $val['id'], '', $usname_list); 	    
		    }
		}
	}

	function getUname($typeInfo)
    {   static $ret = false;
        global $db;
		$id = $this->getUserId();
		switch ($typeInfo) {
			case "getPrp":
				$db->query('SELECT prop_id, usname FROM '.$this->table_prefix.'_unisender_prop WHERE user_id='.$id.' AND usname!="email"');
				while ($db->next_record()) {
					$ret[$db->f('prop_id')] = $db->f('usname');
				}
				break;
			case "getMarks":
				$db->query('SELECT id, uname FROM core_users_prop WHERE usname!="email"');
				while ($db->next_record()) {
					$ret[$db->f('id')] = $db->f('uname');
				}
				break;
		}
        return $ret;
    }
}
?>